Android中判断当前API的版本号方法

Android中由于不同版本API会有一些变化,导致一些较早版本可能不支持新的方法,或者某些功能处理过程不太一样,需要判断当前版本然后进行适当的处理。

那么,如何判断当前API的版本号呢?

例如判断api版本号是否大于等于19:

if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {...} 

其中,Build.VERSION_CODES.KITKAT = 19

Build.VERSION.SDK_INT是什么:

public static final int SDK_INT = SystemProperties.getInt("ro.build.version.sdk", 0); 

获取系统属性配置文件中“ro.build.version.sdk”的值,该值即为当前设备的系统版本号。

在Android源码 frameworks\base\core\java\android\os\Build.java 文件中的 Build.VERSION_CODES 类下包含对应各个版本的版本号信息。

以下是Android 7.0版本下的源码:

public static class VERSION_CODES {
  /**
   * Magic version number for a current development build, which has
   * not yet turned into an official release.
   */
  public static final int CUR_DEVELOPMENT = 10000;

  /**
   * October 2008: The original, first, version of Android. Yay!
   */
  public static final int BASE = 1;

  /**
   * February 2009: First Android update, officially called 1.1.
   */
  public static final int BASE_1_1 = 2;

  /**
   * May 2009: Android 1.5.
   */
  public static final int CUPCAKE = 3;

  /**
   * September 2009: Android 1.6.
   */
  public static final int DONUT = 4;

  /**
   * November 2009: Android 2.0
   */
  public static final int ECLAIR = 5;

  /**
   * December 2009: Android 2.0.1
   */
  public static final int ECLAIR_0_1 = 6;

  /**
   * January 2010: Android 2.1
   */
  public static final int ECLAIR_MR1 = 7;

  /**
   * June 2010: Android 2.2
   */
  public static final int FROYO = 8;

  /**
   * November 2010: Android 2.3
   */
  public static final int GINGERBREAD = 9;

  /**
   * February 2011: Android 2.3.3.
   */
  public static final int GINGERBREAD_MR1 = 10;
  /**
   * February 2011: Android 3.0.
   */
  public static final int HONEYCOMB = 11;

  /**
   * May 2011: Android 3.1.
   */
  public static final int HONEYCOMB_MR1 = 12;

  /**
   * June 2011: Android 3.2.
   */
  public static final int HONEYCOMB_MR2 = 13;
  /**
   * October 2011: Android 4.0.
   */
  public static final int ICE_CREAM_SANDWICH = 14;
  /**
   * December 2011: Android 4.0.3.
   */
  public static final int ICE_CREAM_SANDWICH_MR1 = 15;
  /**
   * June 2012: Android 4.1.
   */
  public static final int JELLY_BEAN = 16;
  /**
   * Android 4.2: Moar jelly beans!
   */
  public static final int JELLY_BEAN_MR1 = 17;
  /**
   * Android 4.3: Jelly Bean MR2, the revenge of the beans.
   */
  public static final int JELLY_BEAN_MR2 = 18;
  /**
   * Android 4.4: KitKat, another tasty treat.
   */
  public static final int KITKAT = 19;
  /**
   * Android 4.4W: KitKat for watches, snacks on the run.
   */
  public static final int KITKAT_WATCH = 20
  public static final int L = 21;
  /**
   * Lollipop. A flat one with beautiful shadows. But still tasty. Android 5.0
   */
  public static final int LOLLIPOP = 21;
  /**
   * Lollipop with an extra sugar coating on the outside! Android 5.1
   */
  public static final int LOLLIPOP_MR1 = 22
  /**
   * M is for Marshmallow! Android 6.0
   */
  public static final int M = 23;
  /**
   * N is for ¯\_(ツ)_/¯. Android 7.0
   */
  public static final int N = 24;
 }

以上这篇Android中判断当前API的版本号方法就是小编分享给大家的全部内容了,希望能给大家一个参考,也希望大家多多支持我们。

时间: 2018-03-22

Android高版本API方法如何在低版本系统上做兼容性处理浅析

前言 在最近的开发中需要获取到SIM卡的网络状态,在源码中看到一个方法: TelephonyManager tm =(TelephonyManager)context.getSystemService(TELEPHONY_SERVICE); state =tm.getDataNetworkType(); 但是报错了Call requires API level 24 (current min is 21): android.telephony.TelephonyManager#getDataNe

最新Android版本、代号、对应API/NDK级别、发布时间及市场份额

最新Android版本.API级别与代号对应关系 代号 版本号 API/NDK级别 发布时间 - O 8.0 API level 26 2017-3-21 牛轧糖 Nougat 7.1.1 API level 25 2016-10 7.0 API level 24 2016-08-22 棉花糖 Marshmallow 6.0.1 API level 23 2015-12 6 2015-10-05 棒棒糖 Lollipop 5.1.1 API level 22 2015-04-21 5.1 201

Android 高版本API方法在低版本系统上的兼容性处理

Android 版本更替,新的版本带来新的特性,新的方法. 新的方法带来许多便利,但无法在低版本系统上运行,如果兼容性处理不恰当,APP在低版本系统上,运行时将会crash. 本文以一个具体的例子说明如何在使用高API level的方法时处理好兼容性问题. 例子:根据给出路径,获取此路径所在分区的总空间大小. 在安卓中的文件存储使用参考中提到: 获取文件系统用量情况,在API level 9及其以上的系统,可直接调用File对象的相关方法,以下需自行计算 一般实现 就此需求而言,API leve

sqlserver数据库高版本备份还原为低版本的方法

问题描述:高版本sql备份在低版本sql还原问题(出现媒体簇的结构不正确) 分析原因:sql版本兼容问题,sql server兼容级别是用作向下兼容用,高版本的sql备份在低版本中不兼容 解决方法 : 1.通过管理器的脚本生成向导,把其他数据库 ,表,存储过程等对象的脚本生成,然后在低版本的sql server下执行建立这些对象.. 2.通过dts/ssis,将表中的数据导过去. 此处我们把第1种开发方法 做下详细介绍(以sql2008的其他数据库 还原到sql2005为例). 1.首先我们在s

Android 实现高斯模糊效果且兼容低版本

一.效果演示 项目中用到了高斯模糊效果,查阅过一些资料,考虑到性能问题最终还是选择使用Android自带的RenderScript库来实现,关于使用RenderScript来实现高斯模糊网上也有很多类似的方法,大部分都总结的比较乱,此处算是做一个整理吧,供有类似需求的同学参考及学习. (项目效果图) 简单描述项目效果图的实现思路: ① 加载定义的xml的Layout ② 使用截屏方法获取当前窗口的Bitmap对象 ③ 将Bitmap对象进行压缩及高斯模糊处理 ④ 将处理过的模糊图对象作为①中所加

SqlServer高版本数据备份还原到低版本

最近遇见一个问题: 想要将Sqlserver高版本备份的数据还原到低版本SqlServer上去,但是这在SqlServer中是没法直接还原数据库的,所以经过一系列的请教总结出来一下可用方法. 首先.你得在电脑上装有你将要操作的高版本以及低版本的SqlServer或者你能够连上SqlServer高版本所在的数据库(便于后面拷贝数据), 第二步.打开高版本数据库中你需要备份的数据库,将你备份的数据库相关的登录名或者用户删除.右键数据库->任务->生成脚本.在生成脚本的"选择对象"

jQuery封装placeholder效果实现方法,让低版本浏览器支持该效果

页面中的输入框默认的提示文字一般使用placeholder属性就可以了,即: <input type="text" name="username" placeholder="请输入用户名" value="" id="username"/> 最多加点样式控制下默认文字的颜色 input::-webkit-input-placeholder{color:#AAAAAA;} 但是在低版本的浏览器却不支

Java高版本Api在Android中的使用方法详解

目录 Android插件开启对新Api的支持 常用的需要兼容处理的类: 1. LocalDate日期处理 2. Stream集合流操作 AGP7编译的问题 总结 Android插件开启对新Api的支持 这一天小王导入了一个库,上线之后直接崩了一大片? 找到其中的问题: 什么鬼哦?安卓8.0一下无法使用? 这样上线8.0以下的手机全部闪退了. 查一下才知道需要开启插件启动对Java Api的支持 android { defaultConfig { multiDexEnabled true } co

微信小程序收货地址API兼容低版本解决方法

微信官方在三月底搞了不少事情.开放个人注册权限,蓝牙,与公众号打通,未来还会开发AR,图片识别,文字识别等等能力. 起初大家只是将微信小程序当做玩具看待,相信如今会有很多人把他当成一门技术去研究了.微信小程序的想象空间已经很大. 说说新增API之一的收货地址.虽然看看兼容低版本. 先上图. API很简单,就一行代码 wx.chooseAddress(OBJECT) 调起的是原生页面,体验很不错.对电商类的小程序比较有利. 不过API是从微信客户端 6.5.6 版本开始支持.这让我想起来做andr

SQLServer数据库从高版本降级到低版本实例详解

SQLServer数据库从高版本降级到低版本实例详解 由于目前还广泛使用着SQLServer2000,很多公司又想使用新的SQLServer,从而直接[分离/附加]或者[备份/还原]数据库,在不同版本之间存放.往往就会遇到版本不兼容的问题.前几天遇到了从我本机2008R2上备份的一个数据库还原到2008上面时报错: 从运行版本10.50.2500(2008R2是10.50)和10.00.1600(2008是10.00)中可以看出这个版本不兼容问题,大部分情况下,从低版本升级到高版本,只要不是跨度

Android SdkVersion的区别及获取版本信息方法

1.minSdkVersion,targetSdkVersion,maxSdkVersion,compileSdkVersion四个数值之间有什么区别? • minSdkVersion,maxSdkVersion是项目支持的最低sdk版本和最高sdk版本.在安装apk前,系统会对这两个数值进行判断,决定当前系统是否可以安装,一般maxSdkVerson不会设置. • compileSdkVersion是项目编译时的sdk版本. • targetSdkVersion 会告诉系统,此版本已经经过充分